=== debian/changelog ===
gvmd (26.15.0-1) unstable; urgency=medium

  * New upstream version 26.15.0
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Fri, 30 Jan 2026 16:30:53 +0100
