## gvmd 26.16.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,11 +2,11 @@
 #
 # SPDX-License-Identifier: AGPL-3.0-or-later
 
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.18)
 
 message("-- Configuring Greenbone Vulnerability Manager...")
 
-project(gvm VERSION 26.15.0 LANGUAGES C)
+project(gvm VERSION 26.16.1 LANGUAGES C)
 
 if(POLICY CMP0005)
   cmake_policy(SET CMP0005 NEW)
@@ -96,7 +96,7 @@
 
 ## Variables
 
-set(GVMD_DATABASE_VERSION 266)
+set(GVMD_DATABASE_VERSION 269)
 
 set(GVMD_SCAP_DATABASE_VERSION 22)
 
@@ -351,10 +351,12 @@
 )
 set(LINKER_HARDENING_FLAGS "-Wl,-z,relro -Wl,-z,now")
 
-# To find unused functions, add: -flto -fwhole-program -ffunction-sections -Wl,--gc-sections -Wl,--print-gc-sections
+set(UNUSED_FUNCTIONS_FLAGS "")
+# Enable this to find unused functions, and search for "removing" in output.
+#set(UNUSED_FUNCTIONS_FLAGS "-flto -fwhole-program -ffunction-sections -Wl,--gc-sections -Wl,--print-gc-sections")
 set(
   CMAKE_C_FLAGS
-  "${CMAKE_C_FLAGS} -Wall -D_BSD_SOURCE -D_ISOC99_SOURCE -D_SVID_SOURCE -D_DEFAULT_SOURCE -D_FILE_OFFSET_BITS=64 ${COVERAGE_FLAGS}"
+  "${CMAKE_C_FLAGS} ${UNUSED_FUNCTIONS_FLAGS} -Wall -D_BSD_SOURCE -D_ISOC99_SOURCE -D_SVID_SOURCE -D_DEFAULT_SOURCE -D_FILE_OFFSET_BITS=64 ${COVERAGE_FLAGS}"
 )
 
 set(
@@ -407,9 +409,3 @@
   FILES src/schema_formats/rnc.xsl src/schema_formats/HTML/HTML.xsl
   DESTINATION
     ${GVMD_DATA_DIR}/global_schema_formats/02052818-dab6-11df-9be4-002264764cea/
-  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
-)
-
-install(
-  FILES src/schema_formats/HTML/generate
-  DESTINATION
