=== src/CMakeLists.txt ===
--- 
+++ 
@@ -71,8 +71,7 @@
   message(SEND_ERROR "The PostgreSQL library is required.")
 endif(NOT PostgreSQL_FOUND)
 string(
-  REGEX MATCH
-  "^[ \t]*\([0-9]+\)\\.\([0-9]+\)\(.*\)"
+  REGEX MATCH "^[ \t]*\([0-9]+\)\\.\([0-9]+\)\(.*\)"
   TEMP
   "${PostgreSQL_VERSION_STRING}"
 )
@@ -153,12 +152,19 @@
   ${PostgreSQL_SERVER_INCLUDE_DIRS}
 )
 
+# PostgreSQL headers and macros trigger -Wredundant-decls in this file.
+set_source_files_properties(
+  manage_pg_server.c
+  PROPERTIES COMPILE_OPTIONS "-Wno-redundant-decls"
+)
+
 # Source lists
 set(
   ALL_MANAGE_SRC
   manage.c
   manage_acl.c
   manage_alerts.c
+  manage_asset_keys.c
   manage_credential_store_cyberark.c
   manage_credential_stores.c
   manage_configs.c
@@ -171,6 +177,7 @@
   manage_license.c
   manage_openvas.c
   manage_osp.c
+  manage_permissions.c
   manage_port_lists.c
   manage_preferences.c
   manage_resources.c
@@ -183,11 +190,13 @@
   manage_tls_certificates.c
   manage_utils.c
   manage_migrators.c
+  manage_permissions.c
   manage_pg.c
   manage_scan_handler.c
   manage_scan_queue.c
   manage_oci_image_targets.c
   manage_container_image_scanner.c
+  manage_targets.c
   manage_users.c
 )
 
@@ -214,11 +223,15 @@
   manage_sql_groups.c
   manage_sql_nvts.c
   manage_sql_secinfo.c
+  manage_sql_permissions.c
+  manage_sql_permissions_cache.c
   manage_sql_port_lists.c
   manage_sql_configs.c
   manage_sql_report_configs.c
   manage_sql_report_formats.c
+  manage_sql_resources.c
   manage_sql_roles.c
+  manage_sql_targets.c
   manage_sql_tickets.c
   manage_sql_tls_certificates.c
   manage_sql_users.c
@@ -456,19 +469,3 @@
     $<TARGET_OBJECTS:all-misc-obj>
     $<TARGET_OBJECTS:all-sql-obj>
   )
-  add_unit_test(manage-oci-image-targets "${ALL_OBJECTS}" "${ALL_MANAGE_SRC}")
-endif()
-
-set(
-  ALL_OBJECTS
-  $<TARGET_OBJECTS:all-gmp-obj>
-  $<TARGET_OBJECTS:all-manage-obj>
-  $<TARGET_OBJECTS:all-misc-obj>
-  $<TARGET_OBJECTS:all-sql-obj>
-)
-add_unit_test(manage-sql "${ALL_OBJECTS}" "${ALL_MANAGE_SQL_SRC}")
-
-set(
-  ALL_OBJECTS
-  $<TARGET_OBJECTS:all-gmp-obj>
-  $<TARGET_OBJECTS:all-manage-sql-obj>
