=== debian/changelog ===
gvmd (26.16.1-1) unstable; urgency=medium

  * New upstream version 26.16.1
  * Update debian/copyright
  * Refresh patches
  * Bump Standards-Version to 4.7.3

 -- Sophie Brun <sophie@kali.org>  Tue, 24 Feb 2026 17:27:22 +0100
