=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
                xml-twig-tools,
                xmltoman,
                xsltproc
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Rules-Requires-Root: no
 Homepage: https://www.greenbone.net/
 Vcs-Git: https://salsa.debian.org/pkg-security-team/gvmd.git
